#
# spec file for package mod_php4 (Version 4.3.3)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org
#

# neededforbuild  aolserver apache-devel-packages apache2-devel-packages compat curl curl-devel cyrus-sasl2 cyrus-sasl2-devel db-devel des expat freetype2 freetype2-devel gd gd-devel gdbm gettext glib-devel gmp gpp gtk-devel heimdal heimdal-devel heimdal-lib imap imap-devel imap-lib jakarta-tomcat java2 libgpp libiodbc libiodbc-devel libjpeg libmcal libmcrypt libmcrypt-devel libpng-devel-packages libtiff libxml2 libxml2-devel lynx mhash mhash-devel mod_dav mysql-devel mysql-shared openldap2 openldap2-client openldap2-devel openssl openssl-devel orbit orbit-devel postgresql-devel postgresql-libs qt3-devel-packages readline readline-devel recode recode-devel sablot sablot-devel t1lib t1lib-devel ucdsnmp x-devel-packages xpm zip
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-Mesa XFree86-Mesa-devel XFree86-devel XFree86-libs aolserver apache apache-devel apache2 apache2-devel apache2-prefork autoconf automake binutils cracklib curl curl-devel cyrus-sasl-devel db-devel des e2fsprogs-devel expat fontconfig fontconfig-devel freetype2 freetype2-devel gcc gcc-c++ gd gd-devel gdbm gettext glib-devel glibc-32bit gmp gtk-devel heimdal heimdal-devel heimdal-lib imap imap-devel imap-lib jakarta-tomcat java2 java2-jre libapr0 libiodbc libiodbc-devel libjpeg liblcms liblcms-devel libmcal libmcrypt libmcrypt-devel libmng libmng-devel libpng libpng-devel libstdc++-devel libtiff libtool libxml2 libxml2-devel lynx mesa mesaglut mesaglut-devel mhash mhash-devel mm mod_dav mod_ssl mysql-devel mysql-shared openldap2 openldap2-devel openssl-devel orbit orbit-devel perl postgresql-devel postgresql-libs qt3 qt3-devel readline-devel recode recode-devel rpm sablot sablot-devel t1lib t1lib-devel ucdsnmp update-desktop-files zip

Name:         mod_php4
%define apache_mmn        %(MMN=$(apxs  -q LIBEXECDIR)/MMN; test -x $MMN && $MMN)
%define apache2_mmn       %(MMN=$(apxs2 -q LIBEXECDIR)/MMN; test -x $MMN && $MMN)
%define apache_libexecdir %(apxs -q LIBEXECDIR)
%define apache_sysconfdir %(apxs -q SYSCONFDIR)
%define apache_includedir %(apxs -q INCLUDEDIR)
%define apache_serverroot %(apxs -q PREFIX)
%define apxs2              apxs2-prefork
%define apache2_libexecdir %(%{apxs2} -q LIBEXECDIR)
%define apache2_sysconfdir %(%{apxs2} -q SYSCONFDIR)
%define apache2_includedir %(%{apxs2} -q INCLUDEDIR)
%define apache2_serverroot %(%{apxs2} -q PREFIX)
%define java_jdkdir       %(find %{_libdir} /usr/lib -type d -name jdk\* -o -type d -name j2sdk\* -o -name kaffe -o -name IBMJava2-\* -o -name SunJava1-\* -o -name SunJava2-\* -maxdepth 1 | sort | head -n 1)
%define java_incdir       %(dirname `find %{java_jdkdir} -follow -name jni.h | grep -v include-old`)
%define qtdom_dir         %{_libdir}/qt3
%define dom_dir           %{_oldincludedir}/libxml2
%if %ul_version >= 1
%define VENDOR UnitedLinux
%else
%define VENDOR SuSE
%endif
Version:      4.3.3
Release:      201
License:      Other License(s), see package
Group:        Productivity/Networking/Web/Servers
Provides:     mod_php
Requires:     %{name}-core = %{version}
Requires:     apache %{apache_mmn}
Autoreqprov:  on
PreReq:       %fillup_prereq
Source0:      ftp://ftp.php.net/pub/version4/downloads/php-%{version}.tar.bz2
Source2:      http://reality.sgi.com/grafica/flash/dist.99.linux.tar.bz2
Source3:      asp2php-0.76.12.tar.bz2
Patch0:       php-%{version}.diff
Patch1:       php-%{version}-suse.diff
Patch2:       php-%{version}-lib64.diff
Patch3:       php-%{version}-ini.diff
Patch4:       php-%{version}-autoconf.diff
Patch5:       php-%{version}-swf.diff
Patch6:       php-%{version}-phpize.diff
Patch7:       php-%{version}-libtool.diff
Patch8:       php-%{version}-ftp.diff
Patch9:       php-%{version}-array.diff
Patch10:      php-%{version}-secfix1.diff
Patch11:      php-%{version}-secfix2.diff
Patch19:      php4-safe_mode.patch
Patch20:      php4-var_unserializer.patch
Patch21:      php4-unserializer-long.patch 
Patch25:      php4-sapi_off_by_one.patch
Patch27:      php-%{version}-save_path-segfault.patch
Patch28:      php-%{version}-basedir-fix.patch
# security fixes, bug #42949
Patch50:      php_43_memory_limit_in_execution.diff
Patch51:      php_43_everything_except_mm.diff
Patch52:      php-4.3.7-sfix.diff
Patch55:      image-dos-php4.patch
Patch56:      var_unserializer-speed-php4.patch
Patch57:      CAN-2005-1042_1043.patch
Patch58:      php-RPC-CAN-2005-1921.patch
Patch59:      php-RPC-CAN-2005-2498.patch
Patch60:      pcre-overflow-bug-106209.patch
Patch61:      php-%{version}-CVE-2005-3353.patch
Patch62:      php-%{version}-CVE-2005-3388.patch
Patch63:      php-%{version}-CVE-2005-3389.patch
Patch64:      php-%{version}-CVE-2005-3390.patch
Patch65:      php-%{version}-mod_rewrite-fix.patch
Patch66:      php-%{version}-mbstring.patch
Patch67:      php-%{version}-CVE-2005-3391.patch
Patch68:      php-%{version}-CVE-2005-3392.patch
URL:          http://www.php.net/
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
Icon:         php4.xpm
Summary:      Latest version of the HTML embedded scripting language
%prep
%setup -q -n php-%{version}
%setup -q -n swf -c swf -a 2 -T
%ifarch %ix86
mkdir -p dist/include/
mkdir -p dist/lib/
mv dist/*.h dist/include/
mv dist/*.a dist/lib/
%endif
%setup -q -n php-%{version} -c php-%{version} -a 3 -T -D
%patch50 -p1
%patch51 -p1
%patch52 -p1
%patch
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
%patch9
%patch10
%patch11
%patch19
%patch20
%patch21 -p1
%patch25 -p1
%patch27
%patch28
%patch55
%patch56
%patch57 -p1
# patch XML_RPC security problem. CAN-2005-1921
pushd pear/packages/
        mkdir x
        cd x
                tar xvf ../XML_RPC-1.0.4.tar
                patch XML_RPC-1.0.4/RPC.php <%{PATCH58}
		patch -p0  <%{PATCH59}
                tar cvf ../XML_RPC-1.0.4.tar *
        cd ..
        rm -rf x
popd
pushd ext/pcre/pcrelib
%patch60
popd
%patch61
%patch62
%patch63
%patch64
%patch65
%patch66
%patch67
%patch68
touch ext/standard/var_unserializer.c
/usr/share/apache2/get_module_list

%build
if [ ! -e %{_oldincludedir}/libxml ] ; then
    if [ -e %{_oldincludedir}/libxml2/libxml/ ] ; then
	ln -s %{_oldincludedir}/libxml2/libxml/ %{_oldincludedir}/libxml
    fi
fi
libtoolize -f
aclocal
autoconf
# real make see install section ...

%install
######################
# Dynamic options
######################
AddDynamicOpts()
{
  DYNAMIC_OPTS="$DYNAMIC_OPTS $@"
}
DYNAMIC_OPTS=""
test -e %{_libdir}/libssl.so && AddDynamicOpts --with-openssl
test -e %{_bindir}/curl-config && AddDynamicOpts --with-curl
%ifarch %ix86
 AddDynamicOpts --with-swf=$RPM_BUILD_DIR/swf/dist/
%endif
%ifnarch ppc
 AddDynamicOpts --with-imap-ssl
%endif
%ifnarch alpha
 AddDynamicOpts --enable-xslt --with-xslt-sablot
%endif
%ifarch ia64 alpha x86_64 sles8-s390 sles8-s390x
 AddDynamicOpts --without-iconv
%else
 AddDynamicOpts --with-iconv
%endif
#########################
# Common options
#########################
COMMON_OPTS="
	--prefix=%{_datadir}
	--datadir=%{_datadir}/php
	--bindir=%{_bindir}
	--libdir=%{_datadir}
	--includedir=%{_includedir}
	--sysconfdir=/etc
	--with-_lib=%{_lib}
	--with-config-file-path=/etc
	--with-exec-dir=%{_libdir}/php/bin
	--disable-debug
	--enable-bcmath
	--enable-calendar
	--enable-ctype
	--enable-dbase
	--enable-discard-path
	--enable-exif
	--enable-filepro
	--enable-force-cgi-redirect
	--enable-ftp
	--enable-gd-imgstrttf
	--enable-gd-native-ttf
	--enable-inline-optimization
	--enable-magic-quotes
	--enable-mbstr-enc-trans
	--enable-mbstring
        --enable-mbregex
	--enable-memory-limit
	--enable-safe-mode
	--enable-shmop
	--enable-sigchild
	--enable-sysvsem
	--enable-sysvshm
	--enable-track-vars
	--enable-trans-sid
	--enable-versioning
	--enable-wddx
	--enable-yp
	--with-bz2
	--with-dom=%{dom_dir}
	--with-ftp
	--with-gdbm
	--with-gettext
	--with-gmp
	--with-imap=yes
	--with-iodbc
	--with-jpeg-dir=%{_usr}
	--with-ldap=yes
	--with-mcal=%{_usr}
	--with-mcrypt
        --with-mhash
	--with-mysql=%{_usr}
	--with-ndbm
	--with-pgsql=%{_usr}
	--with-png-dir=%{_usr}
        --with-readline
	--with-snmp
	--with-t1lib
	--with-tiff-dir=%{_usr}
	--with-ttf
	--with-freetype-dir=yes
	--with-xml
	--with-xpm-dir=%{_usr}/X11R6
	--with-zlib=yes
	--with-qtdom=%{qtdom_dir}
	--with-gd
"
# options which don't work yet, but should be activated ASAP:
#
# --enable-satellite --with-mod-dav=%{apache_includedir} --enable-xslt 
# --with-kerberos[=DIR]  --with-recode=%{_oldincludedir}/ 
#################################
# Set CFLAGS, LDFLAGS, java env.
#################################
CFLAGS="$RPM_OPT_FLAGS -fPIC -DHAVE_LIBDL=1 -I%{_oldincludedir}/ucd-snmp -I%{java_incdir} -I%{java_incdir}/linux"
LDFLAGS=""
EXTRA_LIBS="-L%{_usr}/X11R6/%_lib/ -lpng -lXpm -lncurses -lpam -lssl"
export CFLAGS LDFLAGS EXTRA_LIBS
. setJava --devel Java2 || exit 1
########################
# Build and install
########################
rm -f .build-status
BuildStage()
{
  echo -n " - $1 ... " >>.build-status
  shift
  $@ || { echo "failed" >>.build-status; cat .build-status; exit 1; }
  echo "done" >>.build-status
}
Build()
{
  echo "SERVER $1:" >>.build-status
  shift
  rm -f config.cache
  BuildStage configure ./configure $COMMON_OPTS $DYNAMIC_OPTS $@ %{_target_cpu}-suse-linux
  BuildStage make make CLASSPATH=sapi/servlet
  BuildStage install make install INSTALL_ROOT=$RPM_BUILD_ROOT
  BuildStage clean make clean
}
##################################
# Supported servers are:
#  apache, apache2, aol, servlet
##################################
#
# servlet and aol dont compile on AXP
#
%ifnarch alpha
  mkdir -p $RPM_BUILD_ROOT/opt/aolserver/bin
  Build aol --with-aolserver=/opt/aolserver
  Build servlet --with-servlet=/opt/jakarta/tomcat/common --with-java=$JAVA_HOME
%endif
Build apache --with-mm --with-apxs=`which apxs`
Build apache2 --with-apxs2=`which %{apxs2}`
#
# core comes at the end so that ZTS is not supported in the devel package
#
Build core --with-mm
#######################
# apache configuration
#######################
mv README.apache README.%{VENDOR}
#
# apache 1
#
mkdir -p $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules
cat<<-EOF>$RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/%{name}
	Variable:HTTPD_SEC_MOD_PHP
	LoadModule:LoadModule php4_module %{apache_libexecdir}/libphp4.so
	AddModule:AddModule mod_php4.c
	Text:PHP4
	Include:%{apache_sysconfdir}/%{name}.conf
EOF
mkdir -p $RPM_BUILD_ROOT%{_var}/adm/fillup-templates
install -m 644 apache.rc.config $RPM_BUILD_ROOT/%{_var}/adm/fillup-templates/sysconfig.apache-%{name}
mkdir -p $RPM_BUILD_ROOT/%{apache_sysconfdir}
install -m 644 sysconfig.apache $RPM_BUILD_ROOT/%{apache_sysconfdir}/%{name}.conf
#
# apache 2
#
mkdir -p $RPM_BUILD_ROOT/%{apache2_sysconfdir}/conf.d
install -m 644 sysconfig.apache2 $RPM_BUILD_ROOT/%{apache2_sysconfdir}/conf.d/%{name}.conf
########################################################
# generate php.ini from php.ini-dist:
#   - add extension_dir
#   - add modules to section [extension section]
# leave only shared objects in extension dir
########################################################
EXTDIR=`sh scripts/php-config --extension-dir`
cat <<EOF>script.sed
/extension_dir = /a\\
extension_dir = $EXTDIR
/\[extension section]/a\\
EOF
for i in $EXTDIR/*; do
  if test ${i##*.} = so; then
    echo "extension = ${i##*/}\\" >>script.sed
    # reset vim syntax highlighting: "
  else
    rm -f $i
  fi
done
echo "; end of extension section" >>script.sed
sed -f script.sed php.ini-dist >$RPM_BUILD_ROOT/etc/php.ini
echo "%%dir "`dirname $EXTDIR` >extension-dir
echo $EXTDIR >>extension-dir
#####################
# headers for devel
#####################
mkdir -p $RPM_BUILD_ROOT%{_includedir}/php
find . -path ./win32 -prune -o -type f -name \*.h -not -path \*w32\* -not -path \*win\* -exec install -D -m 644 {} $RPM_BUILD_ROOT/%{_includedir}/php/{} \;
###################
# swf fonts
###################
%ifarch %ix86
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/php/swffonts
cp $RPM_BUILD_DIR/swf/dist/fonts/* $RPM_BUILD_ROOT/%{_datadir}/php/swffonts
%endif
#####################
# asp2php
#####################
pushd asp2php-0.76.12
	make all gui
	mkdir -p $RPM_BUILD_ROOT/%{_usr}/X11R6/bin
	install -m 755 asp2php $RPM_BUILD_ROOT/%{_bindir}
	install -m 755 gtkasp2php $RPM_BUILD_ROOT/%{_usr}/X11R6/bin/
popd
#####################
# misc
#####################
chmod -R go-w $RPM_BUILD_ROOT/%{_datadir}/php $RPM_BUILD_ROOT/%{_bindir}/pear
%ifnarch alpha
 IfNotEmpty() { test -s $RPM_BUILD_ROOT/$2 && $1 $RPM_BUILD_ROOT/$2 ${3:+$RPM_BUILD_ROOT/}$3 ||:; }
 mkdir -p $RPM_BUILD_ROOT/opt/jakarta/tomcat/common/lib
 IfNotEmpty mv %{_datadir}/phpsrvlt.jar /opt/jakarta/tomcat/common/lib/
 IfNotEmpty mv %{_datadir}/libphp4.so   /opt/jakarta/tomcat/common/lib/
%endif
####################
# testing
####################
#
# php binary
#
$RPM_BUILD_ROOT/%{_bindir}/php test.php > %{_tmppath}/test.html || exit 1
lynx -dump %{_tmppath}/test.html | gawk '/^Environment/ {exit} {print}' >README.ENABLED_FEATURES
#
# apache1
#
echo -e "LoadModule php4_module $RPM_BUILD_ROOT/%{apache_libexecdir}/libphp4.so\n" >%{apache_sysconfdir}/suse_loadmodule.conf
echo -e "AddModule mod_php4.c\n" >%{apache_sysconfdir}/suse_addmodule.conf
httpd -t || exit 1
#
# apache2
#
mkdir -p %{apache2_sysconfdir}/sysconfig.d
echo -e "LoadModule php4_module $RPM_BUILD_ROOT/%{apache2_libexecdir}/libphp4.so\n" >>%{apache2_sysconfdir}/sysconfig.d/suse_loadmodule.conf
touch %{apache2_sysconfdir}/sysconfig.d/include.conf
httpd2 -t -f /etc/apache2/httpd.conf -e debug || exit 1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%{apache_libexecdir}/libphp4.so
%{_var}/adm/fillup-templates/sysconfig.apache-%{name}
%{apache_sysconfdir}/modules/%{name}
%{apache_sysconfdir}/%{name}.conf

%post
%{fillup_only -an apache}
%ifnarch alpha
%package aolserver
Summary:      PHP4 for the AOL server
Group:        Productivity/Networking/Web/Servers
Requires:     aolserver
Requires:     %{name}-core = %{version}
%endif
%package core
Summary:      core files of PHP4
Provides:     php php4 zend
Group:        Productivity/Networking/Web/Servers
%package -n apache2-mod_php4
Summary:      Latest version of the HTML embedded scripting language
Group:        Productivity/Networking/Web/Servers
Requires:     apache2-prefork %{apache2_mmn}
Requires:     %{name}-core = %{version}
Provides:     mod_php
%package devel
Summary:      Include files of PHP4
Group:        Development/Libraries/C and C++
Requires:     %{name}-core = %{version}
%ifnarch alpha
%package servlet
Summary:      PHP4 as a Jakarta servlet
Group:        Productivity/Networking/Web/Servers
Requires:     jakarta-tomcat
Requires:     %{name}-core = %{version}
%endif
%ifnarch alpha

%files aolserver
%defattr(-, root, root)
%doc sapi/aolserver/README
/opt/aolserver/bin/libphp4.so
%endif
%ifnarch alpha

%files servlet
%defattr(-, root, root)
%doc sapi/servlet/web.xml sapi/servlet/README
%dir /opt/jakarta
/opt/jakarta/tomcat/common/lib/phpsrvlt.jar
/opt/jakarta/tomcat/common/lib/libphp4.so
%endif

%files devel
%defattr(-, root, root)
%{_includedir}/php
%{_bindir}/phpize
%dir %{_datadir}/lib
%dir %{_datadir}/lib/php
%{_datadir}/lib/php/build

%files core -f extension-dir
%defattr(-, root, root)
%doc READ* CODING_STANDARDS CREDITS 
%doc INSTALL 
%doc LICENSE NEWS TOD* 
%doc test.php
%{_mandir}/man1/*
%{_datadir}/php/
%config /etc/php.ini
%config /etc/pear.conf
%{_bindir}/phpextdist
%{_bindir}/php
%{_bindir}/php-config 
%{_bindir}/pear
%{_bindir}/asp2php
%{_usr}/X11R6/bin/gtkasp2php

%files -n apache2-mod_php4
%defattr(-, root, root)
%{apache2_libexecdir}/libphp4.so
#%{_var}/adm/fillup-templates/sysconfig.apache2-%{name}
#%{apache2_sysconfdir}/modules/%{name}
%config(noreplace) %{apache2_sysconfdir}/conf.d/%{name}.conf

%description
PHP is a server-side, cross-platform, HTML embedded scripting language.
If you are completely new to PHP and want to get some idea of how it
works, have a look at the Introductory Tutorial.  Once you get beyond
that have a look at the example archive sites and some of the other
resources available in the Links section.

Please refer to /usr/share/doc/packages/mod_php4-core/README.SuSE for
information on how to load the module into the Apache webserver.



Authors:
--------
    Andrei Zmievski <andrei@ispi.net>
    Danny Heijl <Danny.Heijl@cevi.be>
    Frank M. Kromann <fmk@swwwing.com>
    Rasmus Lerdorf <rasmus@php.net>
    Sam Ruby <rubys@us.ibm.com>
    Sascha Schumann <sascha@schumann.cx>
    Stefan Roehrich <sr@linux.de>
    Thies C. Arntzen <thies@digicol.de>
    Uwe Steinmann <steinm@php.net>

%ifnarch alpha

%description servlet
PHP is a server-side, cross-platform, HTML embedded scripting language.
If you are completely new to PHP and want to get some idea of how it
works, have a look at the Introductory Tutorial.  Once you get beyond
that have a look at the example archive sites and some of the other
resources available in the Links section.



%endif

%description devel
PHP is a server-side, cross-platform, HTML embedded scripting language.
If you are completely new to PHP and want to get some idea of how it
works, have a look at the Introductory Tutorial.  Once you get beyond
that have a look at the example archive sites and some of the other
resources available in the Links section. PHP4 is the latest version.



Authors:
--------
    Andrei Zmievski <andrei@ispi.net>
    Danny Heijl <Danny.Heijl@cevi.be>
    Frank M. Kromann <fmk@swwwing.com>
    Rasmus Lerdorf <rasmus@php.net>
    Sam Ruby <rubys@us.ibm.com>
    Sascha Schumann <sascha@schumann.cx>
    Stefan Roehrich <sr@linux.de>
    Thies C. Arntzen <thies@digicol.de>
    Uwe Steinmann <steinm@php.net>

%ifnarch alpha

%description aolserver
PHP is a server-side, cross-platform, HTML embedded scripting language.
If you are completely new to PHP and want to get some idea of how it
works, have a look at the Introductory Tutorial.  Once you get beyond
that, have a look at the example archive sites and some of the other
resources available in the Links section.



Authors:
--------
        Andrei Zmievski <andrei@ispi.net>
        Danny Heijl <Danny.Heijl@cevi.be>
        Frank M. Kromann <fmk@swwwing.com>
        Rasmus Lerdorf <rasmus@php.net>
        Sam Ruby <rubys@us.ibm.com>
        Sascha Schumann <sascha@schumann.cx>
        Stefan Roehrich <sr@linux.de>
        Thies C. Arntzen <thies@digicol.de>
        Uwe Steinmann <steinm@php.net>

%endif

%description core
This package contains the core files of PHP4. Additionally the modules
for certain webservers like Apache or Roxen may be installed.



Authors:
--------
    Andrei Zmievski <andrei@ispi.net>
    Danny Heijl <Danny.Heijl@cevi.be>
    Frank M. Kromann <fmk@swwwing.com>
    Rasmus Lerdorf <rasmus@php.net>
    Sam Ruby <rubys@us.ibm.com>
    Sascha Schumann <sascha@schumann.cx>
    Stefan Roehrich <sr@linux.de>
    Thies C. Arntzen <thies@digicol.de>
    Uwe Steinmann <steinm@php.net>


%description -n apache2-mod_php4
PHP is a server-side, cross-platform, HTML embedded scripting language.
If you are completely new to PHP and want to get some idea of how it
works, have a look at the Introductory Tutorial.  Once you get beyond
that have a look at the example archive sites and some of the other
resources available in the Links section.

This package contains the mod_php4 module for the Apache 2.0 web
server. It requires the mod_php4-core package to be installed.

Please refer to /usr/share/doc/packages/mod_php4-core/README.SuSE for
information on how to load the module.



Authors:
--------
    Andrei Zmievski <andrei@ispi.net>
    Danny Heijl <Danny.Heijl@cevi.be>
    Frank M. Kromann <fmk@swwwing.com>
    Rasmus Lerdorf <rasmus@php.net>
    Sam Ruby <rubys@us.ibm.com>
    Sascha Schumann <sascha@schumann.cx>
    Stefan Roehrich <sr@linux.de>
    Thies C. Arntzen <thies@digicol.de>
    Uwe Steinmann <steinm@php.net>


%changelog -n mod_php4
* Mon Dec 05 2005 - postadal@suse.cz
- fixed unexpected header can be injected to mb_send_mail()
  [#135673] (mbstring.patch)
- added safe_mode checks for image* functions and cURL
  [#135673] (CVE-2005-3391.patch)
- fixed possible INI setting leak via virtual() in Apache 2 sapi
  [#135673] (CVE-2005-3392.patch)
- fixed mod_rewrite-fix.patch [#135480]
* Mon Nov 28 2005 - postadal@suse.cz
- fixed CVE-2005-3388.patch [#131578]
* Fri Nov 25 2005 - postadal@suse.cz
- fixed segfaulting with mod_rewrite [#135480] (mod_rewrite-fix.patch)
* Mon Nov 14 2005 - mmarek@suse.cz
- fixed infinite recursion in exif code
  [#132684] (CVE-2005-3353.patch)
- fixed XSS in phpinfo()
  [#131578] (CVE-2005-3388.patch)
- fixed register_globals actvation in parse_str()
  [#131579] (CVE-2005-3389.patch)
- fixed possible $GLOBALS overwrite
  [#131580] (CVE-2005-3390.patch)
- fixed handling basedirs that end with a /
  [#118976] (basedir-fix.patch)
- fixed segfaulting when save_path is set and safe_mode is On
  [#130227] (save_path-segfault.patch)
* Thu Sep 01 2005 - postadal@suse.cz
- added security patch pcre-overflow-bug-106209.patch for internal
  libpcre and statically linked against it [#114157]
* Thu Aug 25 2005 - postadal@suse.cz
- linked with system pcre libs [#112645]
- fixed MD5SUMS of XML RPC sources (RPC.php, Server.php) [#104403]
* Thu Aug 18 2005 - postadal@suse.cz
- fixed XML RPC command injection (#104403, CAN-2005-2498)
* Mon Jul 04 2005 - meissner@suse.de
- fixed XML RPC command injection, #94579, CAN-2005-1921
* Fri Apr 15 2005 - mcihar@suse.cz
- fix buffer overflow in exif_process_IFD_TAG (bug #78094, CAN-2005-1042, CAN-2005-1043)
* Thu Apr 07 2005 - mcihar@suse.cz
- fix DoS in image functions (bug #75704, CAN-2005-0524, CAN-2005-0525)
- fix regression in unserializez after last security update (bug #72441)
* Wed Feb 09 2005 - mcihar@suse.cz
- fix crash while passing large data blobs (bug #50565)
* Tue Jan 11 2005 - mcihar@suse.cz
- fix vulnerabilities in unserializer and safe_mode (bug #48635)
- fix broken int unserializing on 64-bit (bug #49617)
* Tue Dec 21 2004 - meissner@suse.de
- fixed build problem.
* Thu Dec 16 2004 - tcrhak@suse.cz
- fixed several vulnerabilities (bug #48635, patch secfix1)
- fixed php.ini settings "leak" from vhosts/.htaccess files
  (bug #48431, patch secfix2)
* Thu Sep 23 2004 - tcrhak@suse.cz
- security fix for array parsing (bug #45710, patch array)
* Wed Jul 14 2004 - lnussel@suse.de
- fix memory limit problem, a problem with strip_tags and several stability
  issues (#42949)
* Mon Sep 22 2003 - mls@suse.de
- remove 'Obsoletes: mod_php' from mod_php4, otherwise rpmv4
  makes mod_php4 conflict with apache2-mod_php4
* Tue Sep 16 2003 - tcrhak@suse.cz
- update to version 4.3.3
* Mon Sep 01 2003 - tcrhak@suse.cz
- expand rpm macros in /etc/httpd/modules/mod_php4 [bug #29664]
* Thu Aug 21 2003 - tcrhak@suse.cz
- update to version 4.3.2
- use BuildRoot
- added activation metadata to sysconfig [bug #28827]
* Mon Aug 18 2003 - poeml@suse.de
- add README.{SuSE,UnitedLinux} [#25888]
- don't explicitely strip binary objects, because RPM does it
  anyway, and it might keep the stripped debugging info somewhere.
- don't try to install a file in /etc/apache2/modules/ (it's gone)
* Mon Jun 30 2003 - ro@suse.de
- always use libtool to compile objects
- added directories to filelist
* Thu Apr 10 2003 - tcrhak@suse.cz
- use 'head -n 1' instead of 'head -1'
- added mhash support
* Wed Mar 26 2003 - tcrhak@suse.cz
- fixed path in script phpize
- fixed ext/mysql/config.m4
* Thu Mar 13 2003 - tcrhak@suse.cz
- fixed order of Type and Define in sysconfig metadata
- readded subpackage servlet (patch servlet)
- reenabled support for swf
- install swf fonts, use proper SWFFONTPATH
  (bug #18057, patch swf)
* Tue Mar 04 2003 - poeml@suse.de
- the apache2 module requires the apache2-prefork MPM
* Thu Feb 20 2003 - tcrhak@suse.cz
- security update to version 4.3.1 - fixes a CGI vulnerability
- added sysconfig metadata [bug #22604]
* Fri Feb 14 2003 - tcrhak@suse.cz
- added php3, php4 to DirectoryIndex [bug #22066]
* Thu Feb 13 2003 - ro@suse.de
- really disable (empty) subpackage servlet
* Wed Feb 12 2003 - poeml@suse.de
- rename subpackage mod_php4_2 to apache2-mod_php4
* Tue Feb 11 2003 - poeml@suse.de
- call the new /usr/share/apache2/get_module_list script to
  configure apache2, so the test can be passed
* Wed Jan 15 2003 - ro@suse.de
- use sasl2
* Fri Jan 10 2003 - poeml@suse.de
- don't built -servlet for now, needs work
- swf.h has vanished from ./dist/include/, and I can't find another
  one --> disabling swf support
* Thu Jan 09 2003 - poeml@suse.de
- update to 4.3.0
- GD library is now bundled with the distribution and it is
  recommended to always use the bundled version
- vpopmail and cybermut extensions are moved to PECL
- several deprecated extensions (aspell, ccvs, cybercash, icap)
  and SAPIs (fastcgi, fhttpd) are removed
- speed improvements in a variety of string functions
- Apache2 filter is improved, but is still considered
  experimental (use with PHP in prefork and not worker (thread)
  model since many extensions based on external libraries are not
  thread safe)
- various security fixes (imap, mysql, mcrypt, file upload, gd, etc)
- new SAPI for embedding PHP in other applications (experimental)
- much better test suite
- significant improvements in dba, gd, pcntl, sybase, and xslt
  extensions
- debug_backtrace() should help with debugging
- error messages now contain URLs linking to pages describing the
  error or function in question
- Zend Engine has some fixes and minor performance enhancements
- and TONS of other fixes, updates, new functions, etc
- build apache2 module
- QtDOM support is now in qt3, and therefore we need to link
  against libqt-mt
- merge the lib64 patch, hope it's complete
- gd lib is now bundled, and preferred for building
- adjust the Provides of the -core package
* Thu Nov 21 2002 - ro@suse.de
- make it build with current automake
* Wed Oct 16 2002 - tcrhak@suse.cz
- added support for readline
- added support for iconv and mbstrings [bugs #19861 and #19862]
* Fri Sep 27 2002 - tcrhak@suse.cz
- added type .php3 to apache mod_php4.conf
* Wed Sep 18 2002 - ro@suse.de
- removed bogus self-provides
* Tue Sep 03 2002 - tcrhak@suse.cz
- fixed to build on 64 bit archs
* Fri Aug 23 2002 - tcrhak@suse.cz
- fixed to build on non-i386 archs
- added dynamic extensions to the file list of subpackage core
* Tue Aug 20 2002 - tcrhak@suse.cz
- added PreReq
* Tue Aug 13 2002 - kukuk@suse.de
- Remove unused qt2 from neededforbuild
* Wed Aug 07 2002 - uli@suse.de
- fixed to build on lib64 archs (still broken on nearly all archs
  due to other problems)
* Mon Aug 05 2002 - ro@suse.de
- use "-follow" when searching for jni.h
* Sun Jul 28 2002 - kukuk@suse.de
- remove unused gdb from neededforbuild
* Sat Jul 27 2002 - adrian@suse.de
- fix neededforbuild
* Fri Jul 26 2002 - kukuk@suse.de
- Add imap-lib to neededforbuild
* Tue Jul 23 2002 - tcrhak@suse.cz
- update to version 4.2.2
- update of asp2php to version 0.76.12
- detect the module magic number if provided by apache, indicating
  API changes, and add an RPM Require on it
- add compiled extensions (currently gd.so, as it is build shared
  by a previous change by bk@suse.de) to php.ini and filelist
* Fri Jul 05 2002 - kukuk@suse.de
- Use %%ix86 macro
* Tue May 28 2002 - ro@suse.de
- replaced /opt/jakarta with /opt/jakarta/tomcat
* Mon May 27 2002 - ro@suse.de
- first try for lib64
* Mon May 27 2002 - bk@suse.de
- use shared libgd on all archs
* Sat Mar 23 2002 - ro@suse.de
- removed unixODBC stuff, was never used (iodbc is used)
* Fri Mar 15 2002 - tcrhak@suse.cz
- added %%{_datadir}/lib/php and extension dir to devel filelist
* Mon Mar 04 2002 - okir@suse.de
- security fix
* Fri Feb 22 2002 - tcrhak@suse.cz
- Killed %%{release} from "Requires" tags.
* Fri Feb 01 2002 - ro@suse.de
- changed neededforbuild <libpng> to <libpng-devel-packages>
* Mon Jan 28 2002 - ro@suse.de
- added des to neededforbuild
* Mon Jan 28 2002 - ro@suse.de
- added heimdal stuff to build
* Wed Jan 23 2002 - ro@suse.de
- try to build with db-devel in neededforbuild
* Thu Jan 17 2002 - ro@suse.de
- adapted for /etc/sysconfig/apache
* Thu Dec 20 2001 - tcrhak@suse.cz
- update to 4.1.0
- no mm support for aol and servlet (mm is not ZTS in 4.1 yet)
- patched acinclude.m4 to find the very dir for mysql libraries
- added `php-config --extension-dir` to core files
* Mon Dec 10 2001 - tcrhak@suse.cz
- fixed extension section
* Thu Dec 06 2001 - tcrhak@suse.cz
- added section [extension section] to php.ini
- fixed options given to configure
* Tue Dec 04 2001 - tcrhak@suse.cz
- fixed configure.in and config.m4's for autoconf 2.52
- added libtoolize, autoconf, autoheader
- used setJava to find JAVA_HOME
- TTF - bug 9523
- gd  - bug 12226
- changed the order in which subpackages (for Servers) are built,
- so that the devel package corresponds to core
- (=> experimental-zts disabled)
- moved phpize to the devel package (fixed for autoconf 2.52)
- added files needed by phpize to the devel package
* Mon Dec 03 2001 - ro@suse.de
- changed servlet dir for configure with jakarta
* Mon Dec 03 2001 - ro@suse.de
- fixed neededforbuild <jakarta> to <jakarta-tomcat>
* Tue Nov 20 2001 - rolf@suse.de
- changes to make IA64 work
- exclude subpackages AOL and Servlet from AXP
* Mon Nov 19 2001 - ro@suse.de
- fix to find java
* Wed Nov 14 2001 - rolf@suse.de
- new subpackage -devel with include files
* Mon Nov 12 2001 - ro@suse.de
- hack for libxml2 include location
* Fri Oct 26 2001 - ro@suse.de
- use qt2 for qtdom (but aparently that is not built anyway)
* Thu Oct 25 2001 - ro@suse.de
- try neededforbuild alias apache-devel-packages
* Tue Sep 11 2001 - ro@suse.de
- remove roxen subpackage
  roxen is not in the distribution currently
* Wed Aug 22 2001 - ro@suse.de
- removed pdflib from neededforbuild (license problems)
* Tue Aug 14 2001 - ro@suse.de
- pear: changed header to look for php in "bindir" not "prefix/bin"
  to fix requires
* Mon Aug 13 2001 - kukuk@suse.de
- Don't conflict with packages we are providing
* Thu Aug 09 2001 - kukuk@suse.de
- Fix search for installed java directory
* Tue Jul 24 2001 - rolf@suse.de
- new subpackage mod_php4-aolserver for use of PHP4 with AOL server
- disable-debug so Zend optimizer can work
* Thu Jul 05 2001 - rolf@suse.de
- update to php 4.0.6
- apply memlimit patch
- new subpackage mod_php4-servlet for use of PHP4 as JAVA servlet
  with tomcat
- new options: --with-gmp, --with-dom, mbstring
* Mon Jun 25 2001 - rolf@suse.de
- fixed bug with pdflib which also fixes [BUG#8246]
* Tue Jun 19 2001 - rolf@suse.de
- new version 4.0.5
- disable pgsql for roxen, as it is broken
- mysql bug fixed in this release [BUG#6839]
- move stuff to /usr/share/php [BUG#8352]
- now Provides: mod_php as well [BUG#8911]
* Sat May 12 2001 - schwab@suse.de
- Use new readline interface.
* Tue May 08 2001 - mfabian@suse.de
- bzip2 sources
* Tue May 01 2001 - kukuk@suse.de
- disable adabas support
* Thu Apr 26 2001 - ro@suse.de
- neededforbuild: curl_ssl-devel -> curl-devel
* Sun Apr 08 2001 - poeml@suse.de
- fix Requires (rearrange tags to define them before using them)
- fix spec file typo
* Tue Mar 27 2001 - rolf@suse.de
- spin off subpackage mod_php4-core which is required by apache and
  roxen modules now
- moved config file to /etc/php.ini for all php4 modules
- sybase support conflicts with Adabas D support
- Ingres support is for Ingres II only
- added t1lib support [BUG#6212]
- updated asp2php 0.75.13
- make us of suse_loadmodule for testing
- added /usr/bin/php to core package [BUG#6648]
* Wed Mar 21 2001 - ro@suse.de
- changed neededforbuild to freetype2
* Thu Mar 15 2001 - ro@suse.de
- build with openldap2
* Thu Mar 15 2001 - ro@suse.de
- fixed neededforbuild for openldap
* Mon Mar 05 2001 - ro@suse.de
- use -fPIC
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Fri Feb 23 2001 - ro@suse.de
- added readline/readline-devel to neededforbuild (split from bash)
* Thu Feb 15 2001 - rolf@suse.de
- new features imap-ssl, bz2, qtdom, ctype, debug, force-cgi-redirect,
  discard_path, sigchild, gd-imgstrttf
- added apache-mod_php4.rc.config
- added /etc/httpd/modules/mod_php4
* Wed Jan 17 2001 - rolf@suse.de
- add libpdf support
* Tue Jan 16 2001 - rolf@suse.de
- update to 4.0.4pl1 due to security issue [BUG#5760]
- remove number4.tar.gz, no longer needed
* Fri Jan 12 2001 - rolf@suse.de
- need expat to compile [BUG#5104]
- subpackage for roxen module
* Fri Jan 12 2001 - cihlar@suse.cz
- fixed to compile with roxe/pike [#4408]
* Tue Dec 19 2000 - rolf@suse.de
- link with libssl
* Tue Dec 19 2000 - rolf@suse.de
- added the asp2php package [BUG#4456]
- roxen/pike still doesnt work
- require RPM group tag via apxs
* Wed Nov 29 2000 - ro@suse.de
- changed neededforbuild <pg_lib> to <postgresql-lib>
* Mon Nov 27 2000 - rolf@suse.de
- added Sablotron support     [BUG#3891]
- added curl support          [BUG#3890]
- added Flash support on i386 [BUG#3209]
- also pack module files in /usr/lib/php/
- moved the exec dir to /usr/lib/php/bin
- include pear binaries
- added the following modules: sockets, shmop, exif, filepro, dbase
  readline, mcrypt, gettext
* Wed Nov 15 2000 - ro@suse.de
- fixed neededforbuild gdlib -> gd gd-devel
* Thu Nov 09 2000 - ro@suse.de
- prefer ndbm.h to db1/ndbm.h
* Mon Nov 06 2000 - ro@suse.de
- added imap-devel to neededforbuild
* Mon Nov 06 2000 - ro@suse.de
- fixed neededforbuild
* Mon Oct 16 2000 - bk@suse.de
- s390: --with-gd=yes -> --with-gd=shared(broken somehow with =yes)
* Mon Oct 16 2000 - rolf@suse.de
- update tp 4.0.3pl1 due to some security breaches
- needed to drop db3 and dbm support, as these are incompatible
- enable FTP support [BUG#3862]
* Wed Sep 13 2000 - fober@suse.de
- s390: suse_update_config, needs-not-forbuild adabas
* Fri Jul 07 2000 - kukuk@suse.de
- Fix Requires and need for build
* Fri Jun 23 2000 - rolf@suse.de
- added support for mcal and calendar functions [BUG#2925]
* Mon Jun 19 2000 - ro@suse.de
- fixed to compile with new postgres
* Mon May 22 2000 - rolf@suse.de
- update to 4.0.0
- --with-java is now broken
* Fri May 12 2000 - rolf@suse.de
- update to 4.0RC2
- a few more options are now functional
* Thu Apr 13 2000 - ro@suse.de
- added mm to neededforbuild
* Thu Mar 30 2000 - rolf@suse.de
- new version 4.0RC1
- many options now work properly
* Wed Mar 01 2000 - rolf@suse.de
- zlib works again
* Tue Feb 22 2000 - rolf@suse.de
- new version 4b4pl1
- now with --enable-thread-safety --with-gd=yes --with-ttf
- imap support is now broken
* Thu Dec 23 1999 - rolf@suse.de
- dynamic JDK path detection
- some fixes in DAV, still doesnt work
- now also runs with IMAP
* Thu Nov 25 1999 - rolf@suse.de
- initial package version 4.0b3
